print('initialising...')
local _map = map
dofile('sys/lua/wrapper.lua')
map = _map
math.randomseed(os.time())
version = "(v.2.1)"
dofile('sys/lua/rpg_aurora/config.lua')

EXPTABLE = {}
for level = 1, 100 do
	EXPTABLE[level] = CONFIG.EXP.CALC(level)
end
EXPTABLE.__index = function(t, k)
	t[k] = CONFIG.EXP.CALC(k)
	return t[k]
end
setmetatable(EXPTABLE, EXPTABLE)

mapName = map'name'
PVPZONE = PVPZONE[mapName] or PVPZONE[CONFIG.DEFAULTMAP]
NOPVPZONE = NOPVPZONE[mapName] or NOPVPZONE[CONFIG.DEFAULTMAP]
NOMONSTERSZONE = NOMONSTERSZONE[mapName] or NOMONSTERSZONE[CONFIG.DEFAULTMAP]
SAFEZONE = SAFEZONE[mapName] or SAFEZONE[CONFIG.DEFAULTMAP]
POTIONZONE = POTIONZONE[mapName] or POTIONZONE[CONFIG.DEFAULTMAP]
MININGZONE = MININGZONE[mapName] or MININGZONE[CONFIG.DEFAULTMAP]
FORGEZONE = FORGEZONE[mapName] or FORGEZONE[CONFIG.DEFAULTMAP]
ENCHANTZONE = ENCHANTZONE[mapName] or ENCHANTZONE[CONFIG.DEFAULTMAP]
SETZONE = SETZONE[mapName] or SETZONE[CONFIG.DEFAULTMAP]
HOUSES = HOUSES[mapName] or HOUSES[CONFIG.DEFAULTMAP]
GROUNDITEMS = {}
TILEZONE = {}
for y = 0, map'ysize' do
	GROUNDITEMS[y], TILEZONE[y] = {}, {}
	for x = 0, map'xsize' do
		GROUNDITEMS[y][x], TILEZONE[y][x] = {}, {}
		for i, v in ipairs(SAFEZONE) do
			TILEZONE[y][x].SAFE = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].SAFE then
				TILEZONE[y][x].NOPVP = true
				TILEZONE[y][x].NOMONSTERS = true
				TILEZONE[y][x].PVP = false
				break
			end
		end
		for i, v in ipairs(NOPVPZONE) do
			TILEZONE[y][x].NOPVP = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].NOPVP then
				TILEZONE[y][x].NOMONSTERS = false
				TILEZONE[y][x].SAFE = false
				break
			end
		end
		for i, v in ipairs(NOMONSTERSZONE) do
			TILEZONE[y][x].NOMONSTERS = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].NOMONSTERS then
				if TILEZONE[y][x].NOPVP then
					TILEZONE[y][x].SAFE = true
				else
					TILEZONE[y][x].SAFE = false
				end
			end
		end
		for i, v in ipairs(PVPZONE) do
			TILEZONE[y][x].PVP = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2]) and i or nil
			if TILEZONE[y][x].PVP then 
				TILEZONE[y][x].NOPVP = false
				TILEZONE[y][x].SAFE = false
				break
			end
		end
		for i, v in ipairs(POTIONZONE) do
			TILEZONE[y][x].POTION = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].POTION then
				TILEZONE[y][x].POT = true
				break
			end
		end
		for i, v in ipairs(MININGZONE) do
			TILEZONE[y][x].MINING = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].MINING then
				TILEZONE[y][x].MINE = true
				break
			end
		end
		for i, v in ipairs(FORGEZONE) do
			TILEZONE[y][x].FORGING = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].FORGING then
				TILEZONE[y][x].FORGE = true
				break
			end
		end
		for i, v in ipairs(ENCHANTZONE) do
			TILEZONE[y][x].ENCHANTING = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
			if TILEZONE[y][x].ENCHANTING then
				TILEZONE[y][x].ENCHANT = true
				break
			end
        end
        for i, v in ipairs(SETZONE) do
            TILEZONE[y][x].SETTING = (x >= v[1][1] and x <= v[2][1] and y >= v[1][2] and y <= v[2][2])
            if TILEZONE[y][x].SETTING then
                TILEZONE[y][x].SET = true
                break
            end
        end
		for i, v in ipairs(HOUSES) do
			TILEZONE[y][x].HOUSE = (x >= v.pos1[1] and x <= v.pos2[1] and y >= v.pos1[2] and y <= v.pos2[2]) and i or nil
			TILEZONE[y][x].HOUSEDOOR = (x == v.door[1] and y == v.door[2]) and i or nil
			TILEZONE[y][x].HOUSEENT = (x == v.ent[1] and y == v.ent[2]) and i or nil
			if TILEZONE[y][x].HOUSE or TILEZONE[y][x].HOUSEDOOR or TILEZONE[y][x].HOUSEENT then break end
		end
	end
end

PLAYERS = {}
PLAYERCACHE = {}
PLAYERSAVE = {}
Player = {}
maxlevel = 100

hudtxt_colorfade = 0

SKY = image('gfx/yates/RPG/1x1.png',320,240,2)
imagescale(SKY,640,480)
imagecolor(SKY,0,0,32)

MINUTES = 0
GLOBAL = {}
GLOBAL.TIME = 0
RAIIN = 0

messages = {
{"No need for alcohol!","Every time you level up you gain 0.5 extra MP!"},
{"Unlucky chance","Spells have a one in three chance of being destroyed on use."},
	{"Regeneration Spell","The Regeneration Spell gives you from 5 to 10 hp per 3 seconds!"},
    {"Enchantments!","Necklaces give you additional bonuses for your stats!"},
    {"Pickaxing","Mining grants Dwarven ores which can be made into almost everything!"},
    {"Premium members","Premium (VIP) members can get better items, houses and have special mining & enchanting areas!"},
    {"The Anal Bagels.","\169150255255www.theanalbagels.eu\169255255255 - Bossing around since 2009."},
    {"Party up!","You can create a party, say \169150255255!help party\169255255255 for more info."},
    {"Keep your things safe!","You can rent a house at any time. Say \169150255255!help house\169255255255 for more info.."},
    {"Watch out!","Above level 8 you start to lose Gold when you die! Go to the bank before you go hunting!" },
    {"Did you know? ..","When depositing or taking out Gold from the bank you can also say \169150255255all\169255255255 instead of an amount." },
    {"Alchemy","Creating a potion at an alchemy station grants you three potions!"},
    {"Pass the whiskey","Check out trading, say \169150255255!help trade\169255255255 for commands."},
    {"Storage","You can now buy chests to store a huge amount of items in your house!"},
    {"It's raining experience!","Whenever it starts to rain, you gain DOUBLE THE EXPERIENCE ON KILL! Don't miss out!"}
}

dofile('sys/lua/rpg_aurora/functions.lua')
dofile('sys/lua/rpg_aurora/admin.lua')
dofile('sys/lua/rpg_aurora/items.lua')
dofile('sys/lua/rpg_aurora/npcs.lua')
if CONFIG.MAXMONSTERS > 0 then
	dofile('sys/lua/rpg_aurora/monsters.lua')
end
dofile('sys/lua/rpg_aurora/hooks.lua')
sn = 1
server = 10001

TMPGROUNDITEMS = {}
TMPHOUSES = {}
local file = io.open(dir .. "" .. map'name' .. ".lua")
if file then
	io.close(file)
	dofile(dir .. "" .. map'name' .. ".lua")
	for y = 0, map'ysize' do
		if TMPGROUNDITEMS[y] then
			for x = 0, map'xsize' do
				if TMPGROUNDITEMS[y][x] then
					for _, j in ipairs(TMPGROUNDITEMS[y][x]) do
						if j < 0 then
							spawnitem(1337, x, y, -j)
						else
							spawnitem(j, x, y)
						end
					end
				end
			end
		end
	end
	for i, v in pairs(TMPHOUSES) do
		for k, l in pairs(v) do
			HOUSES[i][k] = l
		end
	end
	TMPGROUNDITEMS = nil
	TMPHOUSES = nil
end

dofile("/home/ftpuser/cs2d/players.lua")
dofile("/home/ftpuser/cs2d/reroute_details.lua")

save_dir = "/home/ftpuser/cs2d/saves/"

parse("mp_infammo 1")
parse("mp_hud 64")
parse("mp_radar 0")
parse("mp_deathdrop 4")
parse("sv_password " .. CONFIG.PASSWORD)
parse("sv_name [TAB] RPG Bageloria "..version)
parse("sv_fow 0")
parse("mp_maxclientsip 2")
parse("mp_idlekick 0")
parse("sv_usgnonly 1")
parse("trigger rain")
parse("trigger storm")

print('initialisation completed!')