-- BASIC FUNCTIONS --

--[[local _TIMER = {}
local _time = 0

addhook('ms100','TIMERms100',100)
function TIMERms100()
	_time = _time + 100
	for k, v in pairs(_TIMER) do
		if v[2] <= _time then
			v[1](unpack(v, 3))
			_TIMER[k] = nil
		end
	end
end

function addtimer(delay, func, ...)
	if type(func) == 'function' and type(delay) == 'number' then
		for i = 1, #_TIMER+1 do
			if not _TIMER[i] then
				_TIMER[i] = {func, _time+delay, ...}
				return i
			end
		end
	else
		return false
	end
end

function remtimer(id)
	_TIMER[id] = nil
end]]

rem = {}
function rem.talkExhaust(id)
	PLAYERS[tonumber(id)].tmp.exhaust.talk = false
end

function rem.pickExhaust(id)
	PLAYERS[tonumber(id)].tmp.exhaust.pick = false
end

function rem.useExhaust(id)
	PLAYERS[tonumber(id)].tmp.exhaust.use = false
end

function rem.paralyse(id)
	PLAYERS[tonumber(id)].tmp.paralyse = false
end

--[[function drawLine(x1, y1, x2, y2, tbl)
	if not (x1 and y1 and x2 and y2) then
		return false
	end
	tbl = tbl or {}
	local line = image('gfx/weiwen/1x1.png', 0, 0, tbl.mode or 1)
	local x3, y3, rot = (x1+x2)/2, (y1+y2)/2, math.deg(math.atan2(y1-y2, x1-x2))+90
	imagepos(line, x3, y3, rot)
	imagescale(line, tbl.width or 1, math.sqrt((x1-x2)^2+(y1-y2)^2))
	if tbl.color then
		imagecolor(line, tbl.color[1] or 0, tbl.color[2] or 0, tbl.color[3] or 0)
	end
	if tbl.alpha then
		imagealpha(line, tbl.alpha)
	end
	if tbl.blend then
		imageblend(line, tbl.blend)
	end
	return line
end

function laser(id)
	local x, y, rot = player(id, 'x'), player(id, 'y'), math.rad(player(id, 'rot'))
	addtimer(1000, freeimage, drawLine(x, y, x+math.sin(rot)*300, y-math.cos(rot)*300, {width = 10, color = {math.random(0, 255), math.random(0, 255), math.random(0, 255)}, alpha = 0.5}))
	radiussound('weapons/laser.ogg', x, y)
end]]

function table.shuffle(tbl)
	local n = #tbl
	while n > 2 do
		local k = math.random(n)
		tbl[n], tbl[k] = tbl[k], tbl[n]
		n = n - 1
	end
	return tbl
end

function deepcopy(object)
	local lookup_table = {}
	local function _copy(object)
		if type(object) ~= "table" then
			return object
		elseif lookup_table[object] then
			return lookup_table[object]
		end
		local new_table = {}
		lookup_table[object] = new_table
		for index, value in pairs(object) do
			new_table[_copy(index)] = _copy(value)
		end
		return setmetatable(new_table, getmetatable(object))
	end
	return _copy(object)
end

function table.val_to_str ( v )
	if "string" == type( v ) then
		v = string.gsub( v, "\n", "\\n" )
		if string.match( string.gsub(v, "[^'\"]", ""), '^"+$' ) then
			return "'" .. v .. "'"
		end
		return '"' .. string.gsub(v, '"', '\\"' ) .. '"'
	else
		return "table" == type( v ) and table.tostring( v ) or
			tostring( v )
	end
end

function table.key_to_str ( k )
	if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
		return k
	else
		return "[" .. table.val_to_str( k ) .. "]"
	end
end

function table.tostring( tbl )
	local result, done = {}, {}
	for k, v in ipairs( tbl ) do
		if k ~= 'tmp' then
			table.insert( result, table.val_to_str( v ) )
			done[ k ] = true
		end
	end
	for k, v in pairs( tbl ) do
		if not done[ k ] then
			table.insert( result, 
				table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
		end
	end
	return "{" .. table.concat( result, ", " ) .. "}"
end

function table.equal(tbl, tbl2)
	if type(tbl) ~= "table" and type(tbl2) ~= "table" then
		return tbl == tbl2
	end
	for k, v in pairs(tbl) do
		if v ~= tbl2[k] then
			return false
		end
	end
	return true
end

function string:split(delimiter)
	local result = { }
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from  )
	while delim_from do
		table.insert( result, string.sub( self, from , delim_from-1 ) )
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from  )
	end
	table.insert( result, string.sub( self, from  ) )
	return result
end

function inarea(p1, p2, p3, p4, p5, p6)
	if type(p1) == "table" then
		return p1[1] >= p2[1] and p1[1] <= p3[1] and p1[2] >= p2[2] and p1[2] <= p3[2]
	else
		return p1 >= p3 and p1 <= p5 and p2 >= p4 and p2 <= p6
	end
end

function inarray(tbl, var)
	for k, v in pairs(tbl) do
		if table.equal(v, var) then
			return true
		end
	end
	return false
end

--[[function walkable(x, y, safe, water)
	return tile(x, y, 'walkable') and (water or tile(x, y, 'frame') ~= 34) and not (safe and gettile(x, y).SAFE)
end

function dmg(dmg, id, sourcetype, victimtype, atktype)
	return _dmg(dmg, PLAYERS[id].tmp.atk, PLAYERS[id].tmp.def, PLAYERS[id].Level, sourcetype or 0, victimtype or 0, atktype)
end

function _dmg(dmg, atk, def, level, sourcetype, victimtype, atktype)
	local STAB, WR
	if atktype then
		STAB = 1
		WR = 1
	else
		STAB = (sourcetype == atktype) and 1.5 or 1
		WR = CONFIG.RESISTANCE[victimtype][atktype] or 1
	end
	return ((((level*2.5+2)*dmg*atk/def)/50)+2) * STAB * WR * math.random(85, 100)/100
end]]
-- END OF BASIC FUNCTIONS --



-- SERVER FUNCTIONS --

function saveserver()
	local file = io.open(dir .. "" .. map'name' .. ".lua", 'w+') or io.tmpfile()
	
	local tmp = {}
	for y = 0, map'ysize' do
		if GROUNDITEMS[y] then
			for x = 0, map'xsize' do
				if GROUNDITEMS[y][x] and GROUNDITEMS[y][x][1] then
					tmp[y] = tmp[y] or {}
					tmp[y][x] = {}
					for j = 1, #GROUNDITEMS[y][x] do
						tmp[y][x][j] = GROUNDITEMS[y][x][j][3] and -GROUNDITEMS[y][x][j][3] or GROUNDITEMS[y][x][j][1]
					end
				end
			end
		end
	end
	file:write("-- GROUND ITEMS --\n\n")
	for k, v in pairs(tmp) do
		local text = "TMPGROUNDITEMS[" .. table.val_to_str(k) .. "] = " .. table.val_to_str(v) .. "\n"
		file:write(text)
	end
	
	local tmp = {}
	for i, v in pairs(HOUSES) do
		if v.owner then
			tmp[i] = {owner = v.owner, endtime = v.endtime, allow = v.allow, doors = v.doors}
		end
	end
	file:write("\n\n-- HOUSES --\n\n")
	for k, v in pairs(tmp) do
		local text = "TMPHOUSES[" .. table.val_to_str(k) .. "] = " .. table.val_to_str(v) .. "\n"
		file:write(text)
	end
	
	file:write("\n\n-- GLOBAL STORAGES --\n\n")
	for k, v in pairs(GLOBAL) do
		local text = "GLOBAL[" .. table.val_to_str(k) .. "] = " .. table.val_to_str(v) .. "\n"
		file:write(text)
	end
	file:close()
end

function shutdown(delay)
    saveserver()
	if type(delay) ~= 'string' then
		msg('\169255100100Server is shutting down in ' .. math.floor(delay/1000,0.1) .. ' seconds.@C')
		timer(delay,'shutdown', '', 1)
		local pw = math.random(0,9) .. math.random(0,9) .. math.random(0,9) .. math.random(0,9)
		print("PASSWORD = " .. pw)
		parse("sv_password " .. pw)
		return true
	else
		for _, id in ipairs(player(0, 'table')) do
			parse("kick " .. id)
		end
		timer(3000, "parse", "quit")
	end
end

function loadplayer(id)
	if player(id, "usgn") ~= 0 then
        local file = io.open(save_dir..""..player(id, "usgn")..".lua")
        if file then
            io.close(file)
            file = nil
            dofile(save_dir..""..player(id, "usgn")..".lua")
            PLAYERS[id] = PLAYERSAVE[player(id, "usgn")]
            msg2(id,"\169150255150[SERVER]:\169255255255 Save file found!")
        else
            msg2(id,"\169255150150[SERVER]:\169255255255 Failed to load player save! :(")
            msg2(id,"\169255150150[SERVER]:\169255255255 Trying to find cached file..")
            if PLAYERCACHE[player(id, "usgn")] then
                PLAYERS[id] = PLAYERCACHE[player(id, "usgn")]
                msg2(id,"\169150255150[SERVER]:\169255255255 We found a cached file! Phew! We'll make sure it's saved ;)")
            else
                PLAYERS[id] = deepcopy(CONFIG.PLAYERINIT)
                msg2(id,"\169255150150[SERVER]:\169255255255 Failed to find a cached save :(")
            end
            PLAYERCACHE[player(id, "usgn")] = nil
        end
	else
		PLAYERS[id] = deepcopy(CONFIG.PLAYERINIT)
    end
    PLAYERS[id].tmp = {atk = 1, def = 1, spd = 0, usgn = player(id, "usgn"), trade={0,0,0}, party={0,0,0,0}, pot=0, mine=0, forge=0, equip = {}, exhaust = {}}
    PLAYERS[id].usgn = player(id,"usgn")
    if PLAYERS[id].update ~= version then
        PLAYERS[id].Tutorial = {}
        PLAYERS[id].server = 10001
        PLAYERS[id].update = version
    end
    for k, v in ipairs(CONFIG.SLOTS) do
        PLAYERS[id].tmp.equip[k] = {}
    end
	return true
end

function saveplayer(id)
    if PLAYERS[id] then
        local file = io.open(save_dir..""..player(id, "usgn")..".lua", 'w+')
        local text = "PLAYERSAVE[" .. table.val_to_str(player(id,"usgn")) .. "] = " .. table.val_to_str(PLAYERS[id]) .. ""
        file:write(text)
        file:close()
        msg2(id,"\169150255150[SERVER]:\169255255255 Player details saved!")
        return true
    end
end

function updateTime(t)
	GLOBAL.TIME = t or (GLOBAL.TIME + 1)%1440
	if GLOBAL.RAIN == 0 then
		if math.random(100) == 1 then
			GLOBAL.RAIN = 1
			parse("trigger rain")
		end
	elseif GLOBAL.RAIN == 1 then
		if math.random(5) == 1 then
			GLOBAL.RAIN = 2
			parse("trigger storm")
		else
			GLOBAL.RAIN = 3
		end
	elseif GLOBAL.RAIN == 2 then
		if math.random(20) == 1 then
			GLOBAL.RAIN = 3
			parse("trigger storm")
		end
	elseif GLOBAL.RAIN == 3 then
		if math.random(25) == 1 then
			GLOBAL.RAIN = 0
			parse("trigger rain")
		end
	end
	local text = string.format("%02d:%02d", math.floor(GLOBAL.TIME/60),tostring(GLOBAL.TIME%60))
	return GLOBAL.TIME
end

function gettile(x,y)
	return TILEZONE[y][x]
end

function houseexpire(id)
	local house = HOUSES[id]
	if not house.owner then
		return false
    end
    local file = io.open(save_dir..""..house.owner..".lua")
    if file then
        io.close(file)
        file = nil
        dofile(save_dir..""..house.owner..".lua")
    end
	local player = PLAYERSAVE[house.owner]
	for y = house.pos1[2], house.pos2[2] do
		for x = house.pos1[1], house.pos2[1] do
			local ground = GROUNDITEMS[y][x]
			local height = #ground
			while height > 0 do
				local item = ground[height]
				if item[1] == 1337 then
					freeimage(item[2])
					player.Gold = player.Gold + item[3]
					GROUNDITEMS[y][x][height] = nil
				else
					table.insert(player.Inventory, item[1])
					local tile = gettile(x, y)
					if tile.HEAL and ITEMS[item[1]].heal then
						tile.HEAL = tile.HEAL - ITEMS[item[1]].heal
						if tile.HEAL == 0 then
							tile.HEAL = nil
						end
					end
					freeimage(item[2])
					GROUNDITEMS[y][x][height] = nil
				end
				height = height - 1
			end
		end
    end
    local file = io.open(save_dir..""..house.owner..".lua", 'w+')
    local text = "PLAYERSAVE[" .. table.val_to_str(house.owner) .. "] = " .. table.val_to_str(player) .. ""
    file:write(text)
    file:close()
	house.owner, house.endtime, house.allow = nil, nil, {}
	for i, v in ipairs(house.doors) do
		house.doors[i] = {}
	end
end

-- END OF SERVER FUNCTIONS --



-- PLAYERS --

function radiusmsg(words, x, y, radiusx, radiusy, colour)
	if not (radiusx and radiusy) then radiusx, radiusy = 320, 240 end
	local x1, y1, x2, y2 = x-radiusx, y-radiusy, x+radiusx, y+radiusy
	for _, v in ipairs(player(0, 'table')) do
		if player(v, 'x') >= x1 and player(v, 'x') <= x2 and player(v, 'y') >= y1 and player(v, 'y') <= y2 then
			message(v,words, colour)
        else
            if Player[v].bigears == 1 then
                message(v,words, colour)
            end
		end
	end
	return 1
end

function radiussound(sound, x, y, radiusx, radiusy)
	if not (radiusx and radiusy) then radiusx, radiusy = 320, 240 end
	local x1, y1, x2, y2 = x-radiusx, y-radiusy, x+radiusx, y+radiusy
	for _, v in ipairs(player(0, 'table')) do
		if player(v, 'x') >= x1 and player(v, 'x') <= x2 and player(v, 'y') >= y1 and player(v, 'y') <= y2 then
			parse("sv_sound2 " .. v .. " " .. sound)
		end
	end
	return 1
end

function message(id, text, colour)
	if text:sub(-2) == "@C" then
		msg2(id, (colour and "\169" .. tostring(colour) or "") .. text)
	else
		text = text:gsub("\n", "\169")
		local tbl = {}
		repeat
			table.insert(tbl, text:sub(#tbl+1, math.min(#text, (#tbl+1)*90)))
			text = text:sub(#tbl*90)
		until #text == 0
		for k, v in ipairs(tbl) do
			msg2(id, (colour and "\169" .. tostring(colour) or "") .. v)
			break
		end
	end
end

function hudtxt2(id, txtid, text, colour, x, y, align)
	parse("hudtxt2 " .. id .. " " .. txtid .. " \"\169" .. tostring(colour) .. text .. "\" " .. x .. " " .. y .. " " .. align)
end

function getmoney(id)
	return PLAYERS[id].Gold
end

function setmoney(id, money)
	PLAYERS[id].Gold = money
	updateSTATS(id)
	return true
end

function addmoney(id, money)
	if money < 0 and getmoney(id)+money < 0 then
		return false
	end
	if money < 0 then
		msg2(id,"\169255255150[ITEM]:\169255255255 Lost: "..string.sub(money,2).." Gold.")
	elseif money > 0 then
		msg2(id,"\169255255150[ITEM]:\169255255255 Recieved: "..money.." Gold.")
	end
	setmoney(id, getmoney(id)+money)
	return true
end

function addexp(id, exp)
	all = tonumber(id)
		
	PLAYERS[id].Exp = PLAYERS[id].Exp + exp
	local prevlevel = PLAYERS[id].Level
	while PLAYERS[id].Exp >= EXPTABLE[PLAYERS[id].Level+1] do
		PLAYERS[id].Level = PLAYERS[id].Level + 1
	end
	if prevlevel ~= PLAYERS[id].Level then
		Player[id].level = 1
		timer(6000,"parse","lua Player["..id.."].level=0")
		parse("sv_sound2 "..id.." yates/lua/lvlup.ogg")
		Player[id].leveli1 = image("gfx/yates/RPG/level_up_image.png",0,0,2,id)
		imagepos(Player[id].leveli1,320,150,0)
		tween_scale(Player[id].leveli1,4500,0.5,0.5)
		timer(4500,"parse","lua tween_scale("..Player[id].leveli1..",500,0,0)")
		timer(5000,"freeimage",Player[id].leveli1)
        timer(5000,"parse","lua "..Player[id].leveli1.."=nil")
		Player[id].leveli2 = image("gfx/yates/RPG/level_up_circle.png",0,0,100+id)
		imagescale(Player[id].leveli2,0.4,0.4)
		imagecolor(Player[id].leveli2,255,100,0)
		imageblend(Player[id].leveli2,1)
		tween_rotateconstantly(Player[id].leveli2,2)
		timer(4500,"parse","lua tween_scale("..Player[id].leveli2..",500,0,0)")
		timer(5000,"freeimage",Player[id].leveli2)
        timer(5000,"parse","lua "..Player[id].leveli2.."=nil")
		parse('effect "colorsmoke" ' .. player(id, 'x') .. ' ' .. player(id, 'y') .. ' 50 50 255 255 255')
		msg("\169255000255[LEVEL]:\169255255255 "..player(id,"name").." is now level "..PLAYERS[id].Level.."!")
		parse("sethealth "..id.." "..player(id,"maxhealth"))
	end
    updateSTATS(id)
	return true
end

function updateSTATS(id)
    id = tonumber(id)

    hudtxt2(id,15, PLAYERS[id].Level, '255255000', 310,425,2)
    hudtxt2(id,16, "Level", '255255255', 210,425,0)
    hudtxt2(id,17, "Exp", '255255255', 210,439,0)
    hudtxt2(id,18, PLAYERS[id].Gold, '255255000', 310,453,2)
    hudtxt2(id,19, "Gold", '255255255', 210,453,0)

    hudtxt2(id,20, PLAYERS[id].tmp.atk, '255255000', 430,425,2)
    hudtxt2(id,21, "Attack", '255255255', 330,425,0)
    hudtxt2(id,22, PLAYERS[id].tmp.spd, '255255000', 430,439,2)
    hudtxt2(id,23, "Speed", '255255255', 330,439,0)
    hudtxt2(id,24, PLAYERS[id].tmp.def, '255255000', 430,453,2)
    hudtxt2(id,25, "Defence", '255255255', 330,453,0)

    -- EXP
    local pexp = 0
    if PLAYERS[id].Exp == EXPTABLE[PLAYERS[id].Level] then
        pexp = PLAYERS[id].Exp - EXPTABLE[PLAYERS[id].Level] + 1
    else
        pexp = PLAYERS[id].Exp - EXPTABLE[PLAYERS[id].Level]
    end
    hudtxt2(id,40, math.floor(pexp/(EXPTABLE[PLAYERS[id].Level+1]-EXPTABLE[PLAYERS[id].Level])*100).."%", '255255000', 310,439,2)
    tween_scale(Player[id].exp_bar,200,pexp/(EXPTABLE[PLAYERS[id].Level+1]-EXPTABLE[PLAYERS[id].Level]),1)

    if PLAYERS[id].MP > PLAYERS[id].MaxMP then
        PLAYERS[id].MP = PLAYERS[id].MaxMP
    end
    tween_scale(Player[id].mana_bar,200,PLAYERS[id].MP/PLAYERS[id].MaxMP,1)
end

function updateHUD(id, dmg)
    if dmg then
        d = dmg
    else
        d = 0
    end
    local a = (player(id, 'health') - d) / player(id, 'maxhealth')
    local c = a * 255
    local b = 255 - c
    if c < 0 then
        c = 0
    end
    if b > 255 then
        b = 255
    end
    tween_scale(Player[id].hp_bar,200,player(id, 'health') / player(id, 'maxhealth'), 1)
    imagecolor(Player[id].hp_bar, b, c, 0)
end

function bucketcheck(id)
	local x, y = player(id,"tilex"), player(id,"tiley")
	if tile(x-1,y,"frame") == 34
	or tile(x+1,y,"frame") == 34
	or tile(x,y-1,"frame") == 34
	or tile(x,y+1,"frame") == 34
	or tile(x-1,y+1,"frame") == 34
	or tile(x+1,y-1,"frame") == 34
	or tile(x-1,y-1,"frame") == 34
	or tile(x+1,y+1,"frame") == 34
	or tile(x,y,"frame") == 34
	or tile(x,y,"frame") == 34 then
		return true
	end
	return false
end

-- END OF PLAYERS --

-- ITEMS --

function clearinventory(id, slot)
	if slot then
		table.remove(PLAYERS[id].Inventory, slot)
	else
		PLAYERS[id].Inventory = {}
	end
	return true
end

function itemcount(id, itemid)
	local amount, items = 0, {}
	for k, v in ipairs(PLAYERS[id].Inventory) do
		if v == itemid then
			amount = amount + 1
			table.insert(items, k)
		end
	end
	return amount, items
end

function additem(id, itemid, amount, tell)
	if not ITEMS[itemid] or itemid == 0 then return false end
	amount = amount and math.floor(amount) or 1
	if amount == 1 then
		if #PLAYERS[id].Inventory < CONFIG.MAXITEMS then
			table.insert(PLAYERS[id].Inventory, itemid)
			if tell then
				msg2(id,"\169255255150[ITEM]:\169255255255 Recieved: " .. fullname(itemid) .. ".")
			end
			return true
		end
		return false
	else
		local added = 0
		while #PLAYERS[id].Inventory < CONFIG.MAXITEMS and added < amount do
			table.insert(PLAYERS[id].Inventory, itemid)
			added = added + 1
		end
		local remaining = amount - added
		local dropped = 0
		while dropped < remaining do
			spawnitem(itemid, PLAYERS[id].x, PLAYERS[id].y)
			dropped = dropped + 1
		end
		if tell then
			if remaining == 0 then
				msg2(id,"\169255255150[ITEM]:\169255255255 Recieved: " .. fullname(itemid, added) .. ".")
			else
				msg2(id,"\169255255150[ITEM]:\169255255255 Recieved: " .. fullname(itemid, added) .. ". " .. remaining .. " are dropped due to lack of space.")
			end
		end
		return true
	end
end

function removeitem(id, itemid, amount, tell)
	if not ITEMS[itemid] or itemid == 0 then return false end
	amount = amount and math.floor(amount) or 1
	local removed = 0
	local removed = 0
	local has, toremove = itemcount(id, itemid)
	if has >= amount then
		for k, v in ipairs(toremove) do
			if removed < amount then
				table.remove(PLAYERS[id].Inventory, v+1-k)
				removed = removed + 1
			end
			if removed == amount then
				if tell then
					msg2(id,"\169255255150[ITEM]:\169255255255 Lost: "..fullname(itemid, amount)..".")
				end
				return true
			end
		end
	end
	return false
end

function destroyitem(id, itemslot, equip)
	if equip then
		PLAYERS[id].Equipment[itemslot] = nil
	else
		table.remove(PLAYERS[id].Inventory, itemslot)
	end
	return true
end

function spawnitem(itemid, x, y, amount)
	if not ITEMS[itemid] then return false end
	local ground = GROUNDITEMS[y][x]
	local tile = gettile(x, y)
	local item = {itemid}
	if itemid == 1337 then
		item[3] = amount
	else
		if ITEMS[itemid].heal then
			tile.HEAL = (tile.HEAL or 0) + ITEMS[itemid].heal
		end
	end
	ground[#ground+1] = item
	updateTileItems(x, y)
	return true
end

local MAXHEIGHT = CONFIG.MAXHEIGHT
function updateTileItems(x, y)
	local tile = GROUNDITEMS[y][x]
	if #tile ~= 0 then
		for i = 1, #tile do
			local item = tile[i]
			if item and item[2] then
				freeimage(item[2])
				item[2] = nil
			end
		end
	end
	local height = 0
	for i = #tile-MAXHEIGHT+1 > 0 and #tile-MAXHEIGHT+1 or 1, #tile do
		height = height + 1
		local item = tile[i]
		local itemid = item[1]
		local amount = item[3]
		local x = ITEMS[itemid].offsetx and x*32+16+ITEMS[itemid].offsetx or x*32+16
		local y = ITEMS[itemid].offsety and y*32+16+ITEMS[itemid].offsety or y*32+16
		local heightoffset = (height < MAXHEIGHT and height or MAXHEIGHT)*3
		if itemid == 1337 then
			if amount >= 10000 then
				item[2] = image("gfx/yates/RPG/money/10000+_fixed.png", 0, 0, i > 3 and 1 or 0);
			elseif amount >= 5000 then
				item[2] = image("gfx/yates/RPG/money/5000+_fixed.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 1000 then
				item[2] = image("gfx/yates/RPG/money/1000+_fixed.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 500 then
				item[2] = image("gfx/yates/RPG/money/500+_fixed.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 200 then
				item[2] = image("gfx/yates/RPG/money/200+_fixed.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 50 then
				item[2] = image("gfx/yates/RPG/money/50+_fixed2.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 5 then
				item[2] = image("gfx/yates/RPG/money/5+_fixed.png", 0, 0, i > 3 and 1 or 0)
			elseif amount >= 1 then
				item[2] = image("gfx/yates/RPG/money/1+_fixed.png", 0, 0, i > 3 and 1 or 0)
			end
		else
			item[2] = image(ITEMS[itemid].fimage or "gfx/weiwen/circle.png", 0, 0, i > 3 and 1 or 0)
			if ITEMS[itemid].r then
				imagecolor(item[2], ITEMS[itemid].r, ITEMS[itemid].g, ITEMS[itemid].b)
			end
		end
		imagepos(item[2], x - heightoffset, y - heightoffset, ITEMS[itemid].rot or 0)
		local scalex, scaley = ITEMS[itemid].fscalex or 1, ITEMS[itemid].fscaley or 1
		local magnification = math.min(height, 10)/20+0.95
		imagescale(item[2], scalex*magnification, scaley*magnification)
	end
end

function pickitem(id)
	local ground = GROUNDITEMS[PLAYERS[id].y][PLAYERS[id].x]
	local height = #ground
	if height > 0 then
		local item = ground[height]
		if item[1] == 1337 then
			if item[2] then freeimage(item[2]) end
			addmoney(id, item[3])
			GROUNDITEMS[PLAYERS[id].y][PLAYERS[id].x][height] = nil
		elseif additem(id, item[1]) then
			local tile = gettile(PLAYERS[id].x, PLAYERS[id].y)
			if tile.HEAL and ITEMS[item[1]].heal then
				tile.HEAL = tile.HEAL - ITEMS[item[1]].heal
				if tile.HEAL == 0 then
					tile.HEAL = nil
				end
			end
			freeimage(item[2])
			msg2(id,"\169255255150[ITEM]:\169255255255 Picked up: " .. fullname(item[1]) .. ".")
			GROUNDITEMS[PLAYERS[id].y][PLAYERS[id].x][height] = nil
		end
		updateTileItems(PLAYERS[id].x, PLAYERS[id].y)
	end
	return true
end

function dropitem(id, itemslot, equip)
	local removed = false
	local inv = (equip and PLAYERS[id].Equipment or PLAYERS[id].Inventory)
	local ground = GROUNDITEMS[PLAYERS[id].y][PLAYERS[id].x]
	local height = #ground
	if height < 8 then
		if spawnitem(inv[itemslot], PLAYERS[id].x, PLAYERS[id].y) then
			msg2(id,"\169255255150[ITEM]:\169255255255 Dropped: " .. fullname(inv[itemslot]) .. ".")
			if equip then
				updateEQ(id, {[itemslot] = 0}, {[itemslot] = inv[itemslot]})
				inv[itemslot] = nil
			else
				table.remove(inv, itemslot)
			end
		else
			msg2(id,"\169255255150[ITEM]:\169255255255 You may not drop anything here.")
		end
	elseif height >= 8 then
		msg2(id,"\169255150150[SERVER]:\169255255255 Stop being a giant cunt by dropping fuckillions of items here!")
	end
    updateSTATS(id)
end

function fullname(itemid, amount)
	if not amount or amount == 1 then
		return ITEMS[itemid].name
	else
		return amount .. " " .. ITEMS[itemid].plural
	end
end

function inventory(id, page)
	page = page or 0
	local text = "Inventory" .. string.rep(" ", page) .. ","
	for i = page*5+1, (page+1)*5 do
		local name
		if ITEMS[PLAYERS[id].Inventory[i]] then
			name = ITEMS[PLAYERS[id].Inventory[i]].name
		else
			name = PLAYERS[id].Inventory[i] or ""
		end
		text = text .. name .. "|" .. i .. ","
	end
	text = text .. ',,Prev Page,Next Page|Page ' .. page+1
	menu(id, text)
end

function equipment(id)
	local text = "Equipment"
	for i, v in ipairs(CONFIG.SLOTS) do
		text = text .. "," .. (ITEMS[PLAYERS[id].Equipment[i] or 0].name or ("ITEM ID " .. PLAYERS[id].Equipment[i])) .. "|" .. v
	end
	menu(id, text)
end

function itemactions(id, itemslot, equip)
	local itemid
	local text = (equip and "Equip" or "Item") .. " Actions" .. string.rep(" ", itemslot-1) .. ","
	if equip then
		itemid = PLAYERS[id].Equipment[itemslot] or 0
	else
		itemid = PLAYERS[id].Inventory[itemslot] or 0
	end
	for i, v in ipairs(ITEMS[itemid].action) do
		text = text .. v .. ","
	end
	text = text .. string.rep(",", 5-#ITEMS[itemid].action) .. "Examine,Drop,,Destroy|It will be lost forever!"
	menu(id, text)
end

-- END OF ITEMS --



-- EQUIP --

function eat(id, itemslot, itemid, equip)
	radiusmsg(player(id,"name") .. " eats " .. ITEMS[itemid].article .. " " .. ITEMS[itemid].name .. ".", player(id,"x"), player(id,"y"), 384)
	local health = player(id, "health") + ITEMS[itemid].food()
	parse("sethealth " .. id .. " " .. health)
	destroyitem(id, itemslot)
end

function explosion(x, y, size, damage, id)
	for _, m in ipairs(MONSTERS) do
		if math.sqrt((m.x-player(id,'x'))^2+(m.y-player(id,'y'))^2) <= size then
			m:damage(id, math.floor(damage*math.random(60,140)/100), 251)
		end
	end
	parse("explosion " .. x .. " " .. y .. " " .. size .. " " .. damage .. " " .. id)
end

function equip(id, itemslot, itemid, equip)
	local index = equip and "Equipment" or "Inventory"
	local previtems, newitems = {}, {}
	if equip then
		if not additem(id, itemid) then return end
		previtems[itemslot] = PLAYERS[id].Equipment[itemslot] or 0
		PLAYERS[id].Equipment[itemslot] = nil
		newitems[itemslot] = 0
	else
		if ITEMS[itemid].level and PLAYERS[id].Level < ITEMS[itemid].level then
			msg2(id,"\169255255150[ITEM]:\169255255255 You need to be level " .. ITEMS[itemid].level .. " or above to equip it.")
			return
        end
        lvl = checkLevel(id)
        if lvl <= 4 then
            if ITEMS[itemid].premium then
                if lvl ~= 2 then
                    msg2(id,"\169255255150[ITEM]:\169255255255 You need to be a premium member to use this.")
                    return
                end
            end
            if ITEMS[itemid].admin then
                if lvl <= 4 then
                    msg2(id,"\169255255150[ITEM]:\169255255255 You need to be an administrator to use this.")
                    return
                end
            end
        end
		newitems[ITEMS[itemid].slot] = itemid
		if ITEMS[itemid].slot == 4 then
			if PLAYERS[id].Equipment[3] then
				if ITEMS[PLAYERS[id].Equipment[3]].twohand then
					if not additem(id, PLAYERS[id].Equipment[3]) then return end
					previtems[3] = PLAYERS[id].Equipment[3] or 0
					PLAYERS[id].Equipment[3] = nil
					newitems[3] = 0
				end
			end
		elseif ITEMS[itemid].slot == 3 then
			if ITEMS[itemid].twohand then
				if PLAYERS[id].Equipment[4] then
					if not additem(id, PLAYERS[id].Equipment[4]) then return end
					previtems[4] = PLAYERS[id].Equipment[4] or 0
					PLAYERS[id].Equipment[4] = nil
					newitems[4] = 0
				end
			end
		end
		destroyitem(id, itemslot)
		if PLAYERS[id].Equipment[ITEMS[itemid].slot] then
			previtems[ITEMS[itemid].slot] = PLAYERS[id].Equipment[ITEMS[itemid].slot]
			additem(id, PLAYERS[id].Equipment[ITEMS[itemid].slot])
		else
			previtems[ITEMS[itemid].slot] = 0
		end
		PLAYERS[id].Equipment[ITEMS[itemid].slot] = itemid
	end
	updateEQ(id, newitems, previtems)
    updateSTATS(id)
    updateHUD(id, 0)
end

function updateEQ(id, newitems, previtems)
	if not previtems then
		previtems = {}
	end
	if not newitems then return end
	parse("equip " .. id .. " 50; setweapon " .. id .. " 50")
	local hp, spd, atk, def, mp = PLAYERS[id].HP, 0, 0, 0, PLAYERS[id].MaxMP
    PLAYERS[id].MaxMP = 0
    PLAYERS[id].HP = 0
	local equip, strip = playerweapons(id), {50, 41}
	for i, v in pairs(newitems) do
		if previtems[i] then
			if PLAYERS[id].tmp.equip[i].image then
				freeimage(PLAYERS[id].tmp.equip[i].image)
				PLAYERS[id].tmp.equip[i].image = nil
			end
			if PLAYERS[id].tmp.equip[i].equip then
				parse("strip " .. id .. " " .. PLAYERS[id].tmp.equip[i].equip)
				table.insert(strip, PLAYERS[id].tmp.equip[i].equip)
				PLAYERS[id].tmp.equip[i].equip = nil
			end
			if ITEMS[previtems[i]].hpp then
				hp=hp-ITEMS[previtems[i]].hpp
            end
            if ITEMS[previtems[i]].mpp then
                mp=mp-ITEMS[previtems[i]].mpp
            end
			if ITEMS[previtems[i]].speed then
				spd=spd-ITEMS[previtems[i]].speed
			end
			if ITEMS[previtems[i]].atk then
				atk=atk-ITEMS[previtems[i]].atk
			end
			if ITEMS[previtems[i]].def then
				def=def-ITEMS[previtems[i]].def
			end
		end
		if newitems[i] ~= 0 then
			if ITEMS[newitems[i]].hpp then
                hp=hp+ITEMS[newitems[i]].hpp
            end
            if ITEMS[newitems[i]].mpp then
                mp=mp+ITEMS[newitems[i]].mpp
            end
			if ITEMS[newitems[i]].speed then
				spd=spd+ITEMS[newitems[i]].speed
			end
			if ITEMS[newitems[i]].atk then
				atk=atk+ITEMS[newitems[i]].atk
			end
			if ITEMS[newitems[i]].def then
				def=def+ITEMS[newitems[i]].def
			end
			if ITEMS[newitems[i]].equip then
				PLAYERS[id].tmp.equip[i].equip = ITEMS[newitems[i]].equip
				parse("equip " .. id .. " " .. ITEMS[newitems[i]].equip)
                timer(100,"parse","setweapon " .. id .. " " .. ITEMS[newitems[i]].equip)
				table.insert(equip, ITEMS[newitems[i]].equip)
			end
			if ITEMS[newitems[i]].eimage then 
				if not PLAYERS[id].tmp.equip[i].image then
					PLAYERS[id].tmp.equip[i].image = image(ITEMS[newitems[i]].eimage, ITEMS[newitems[i]].static and 0 or 1, 0, (ITEMS[newitems[i]].ground and 100 or 200)+id)
					if ITEMS[newitems[i]].r then
						imagecolor(PLAYERS[id].tmp.equip[i].image, ITEMS[newitems[i]].r, ITEMS[newitems[i]].g, ITEMS[newitems[i]].b)
					end
					local scalex, scaley = ITEMS[newitems[i]].escalex or 1, ITEMS[newitems[i]].escaley or 1
					scalex = scalex * -1
					imagescale(PLAYERS[id].tmp.equip[i].image, scalex, scaley)
					if ITEMS[newitems[i]].blend then
						imageblend(PLAYERS[id].tmp.equip[i].image, ITEMS[newitems[i]].blend)
					end
				end
			end
		end
	end
	for i, v in ipairs(equip) do
		if not inarray(strip, v) then
			parse("setweapon " .. id .. " " .. v)
			parse("strip " .. id .. " 50")
		end
    end
    --[[if PLAYERS[id].tmp.class == 0 then
        if PLAYERS[id].Class == "Warrior" then
            atk = atk + 0.5
            def = def + 0.5
            spd = spd - 1
        elseif PLAYERS[id].Class == "Warlock" then
            mp = mp + PLAYERS[id].Level * 2
            def = def - 0.5
        end
        PLAYERS[id].tmp.class = 1
    end]]
	PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + atk
	PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + def
	PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + spd
    PLAYERS[id].MaxMP = math.floor(PLAYERS[id].MaxMP + mp)
    PLAYERS[id].HP = PLAYERS[id].HP + hp
    local health = player(id,"health")
    parse("setmaxhealth "..id.." "..PLAYERS[id].HP)
    parse("sethealth "..id.." "..health)
	if PLAYERS[id].tmp.def <= 0 then
		PLAYERS[id].tmp.def = 0.1
    end
    parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
end

-- END OF EQUIP --

 -- ADDED --

function free_line(x1,y1,x2,y2)
    for i=1,distance(x1,y1,x2,y2) do
        if tile(math.floor((x1+i*math.cos(math.atan2(y2-y1,x2-x1)))/32),math.floor((y1+i*math.sin(math.atan2(y2-y1,x2-x1)))/32),"walkable")==false then
            return false
        end
    end
    return true
end

function distance(x1,y1,x2,y2)
    return math.floor(math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)))
end

function checkitem(id,itemid,times,ritem)
	local amount, items = 0, {}
	for k, v in ipairs(PLAYERS[id].Inventory) do
		if v == itemid then
			if amount ~= times then
				amount = amount + 1
				if amount == times then
					if ritem == 1 then
						removeitem(id,itemid,times)
					end
					return true
				end
			end
		end
	end
	return false
end

function removeitems(id,item,times)
	for loop = 1, times do
		removeitem(id,item)
	end
end

function prison(id,duration,fee,crime)
	if crime or crime ~= "" or crime ~= " " then
		PLAYERS[id].Prisoncrime = crime
	else
		PLAYERS[id].Prisoncrime = "No description"
	end
	if PLAYERS[id].Prison > 0 then
		PLAYERS[id].Prison = PLAYERS[id].Prison + duration
		PLAYERS[id].Prisonfee = PLAYERS[id].Prisonfee + fee
	else
		PLAYERS[id].Prison = duration
		PLAYERS[id].Prisonfee = fee
	end
	if fee == 0 then
		msg2(id,"\169255150150[SERVER]:\169255255255 You have been imprisoned, time: "..PLAYERS[id].Prison.." - crime: "..PLAYERS[id].Prisoncrime)
		msg2(id,"\169255150150[SERVER]:\169255255255 Wait your time while ON the server, no fee has been set.")
	else
		msg2(id,"\169255150150[SERVER]:\169255255255 You have been imprisoned, time: "..PLAYERS[id].Prison.." - fee: "..PLAYERS[id].Prisonfee.." - crime: "..PLAYERS[id].Prisoncrime)
		msg2(id,"\169255150150[SERVER]:\169255255255 Wait your time while ON the server, or speak to the guard about the fee.")
	end
	parse("setpos "..id.." "..(128*32+16).." "..(110*32+16))
end

-- END OF ADDED --

-- PVP FUNCTIONS --

function pvp_challenge(id)
	local x = math.random(PVPZONE[1][1][1],PVPZONE[1][2][1])
	local y = math.random(PVPZONE[1][1][2],PVPZONE[1][2][2])
	if tile(x,y,"walkable") and tile(x,y,"frame") ~= 12 and tile(x,y,"frame") ~= 34 then
		parse("setpos "..id.." "..(x*32+16).." "..(y*32+16))
	else
		pvp_challenge(id)
	end
end

-- END OF PVP FUNCTIONS --

-- POTION FUNCTIONS --

function potion_func(id)
	id = tonumber(id)
	local atk = 0
	local def = 0
	local spd = 0
	if Player[id].p_speed == 1 then
		spd = spd + 8
		Player[id].p_speed = 2
	end
	if Player[id].p_attack == 1 then
		atk = atk + 2
		Player[id].p_attack = 2
	end
	if Player[id].p_defence == 1 then
		def = def + 2
		Player[id].p_defence = 2
    end
    if Player[id].p_mastery == 1 then
        Player[id].p_mastery = 2
    end
	PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk + atk
	PLAYERS[id].tmp.def = PLAYERS[id].tmp.def + def
	PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd + spd
	parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
    updateSTATS(id)
end

function potion_invisibility(id)
	id = tonumber(id)
	parse("setarmor "..id.." 0")
	if PLAYERS[id].tmp.equip[1].image then
		imagealpha(PLAYERS[id].tmp.equip[1].image,1)
	end
	if PLAYERS[id].tmp.equip[2].image then
		imagealpha(PLAYERS[id].tmp.equip[2].image,1)
	end
	if PLAYERS[id].tmp.equip[3].image then
		imagealpha(PLAYERS[id].tmp.equip[3].image,1)
	end
	msg2(id,"\169255255150[ITEM]:\169255255255 Your potion of invisibility has ended.")
    PLAYERS[id].p_invisibility = 0
end

function potion_haste(id)
	id = tonumber(id)
	PLAYERS[id].tmp.spd = PLAYERS[id].tmp.spd - 8
	parse("speedmod "..id.." "..PLAYERS[id].tmp.spd)
	msg2(id,"\169255255150[ITEM]:\169255255255 Your potion of haste has ended.")
    freeimage(Player[id].p_speedi)
    Player[id].p_speedi = nil
	Player[id].p_speed = 0
    updateSTATS(id)
end

function potion_attack(id)
	id = tonumber(id)
	PLAYERS[id].tmp.atk = PLAYERS[id].tmp.atk - 2
	msg2(id,"\169255255150[ITEM]:\169255255255 Your potion of strength has ended.")
    freeimage(Player[id].p_attacki)
    Player[id].p_attacki = nil
	Player[id].p_attack = 0
    updateSTATS(id)
end

function potion_defence(id)
	id = tonumber(id)
	PLAYERS[id].tmp.def = PLAYERS[id].tmp.def - 2
	msg2(id,"\169255255150[ITEM]:\169255255255 Your potion of defence has ended.")
    freeimage(Player[id].p_defencei)
    Player[id].p_defencei = nil
	Player[id].p_defence = 0
    updateSTATS(id)
end

function potion_mastery(id)
    id = tonumber(id)
    msg2(id,"\169255255150[ITEM]:\169255255255 Your potion of mastery has ended.")
    Player[id].p_mastery = 0
    updateSTATS(id)
end

-- END OF POTIONS FUNCTIONS --

-- STAFF FUNCTIONS --

function _monster_attack(id)
	local weapon, closest = player(id, 'weapontype')
	for _, m in ipairs(MONSTERS) do
		if object(Player[id].staffi1,"x") >= m.x-16 and object(Player[id].staffi1,"x") <= m.x+16 and object(Player[id].staffi1,"y") >= m.y-16 and object(Player[id].staffi1,"y") <= m.y+16 then
			closest = {m}
            freetimer("staff_warlock",id)
			timer(0,"staff_warlock",id)
		end
    end
    if closest then
		closest[1]:damage(id, math.ceil(20*((PLAYERS[id].Level+50)*PLAYERS[id].tmp.atk/closest[1].def)/math.random(60, 140))*3, weapon)
        return
    end
    for _,all in pairs(player(0,"table")) do
        if id ~= all then
            if object(Player[id].staffi1,"x") >= player(all,"x")-16 and object(Player[id].staffi1,"x") <= player(all,"x")+16 and object(Player[id].staffi1,"y") >= player(all,"y")-16 and object(Player[id].staffi1,"y") <= player(all,"y")+16 then
                EXPhit(all,id,0,ITEMS[PLAYERS[id].Equipment[3]].atk*100*2)
                freetimer("staff_warlock",id)
                timer(0,"staff_warlock",id)
                break
            end
        end
    end
end

function staff_warlock(id)
	id = tonumber(id)
	Player[id].staff = 0
    if Player[id].staffi1 then
	    freeimage(Player[id].staffi1)
    end
	Player[id].staffi1 = nil
end