Monster = {name = 'Monster', health = 100, image = 'gfx/weiwen/circle.png', scalex = 1, scaley = 1, atk = 1, def = 1, spd = 5, x = 0, y = 0, ang = 0, imgang = 0, exp = 5, money = 50, type = 'monster', loot = {}}
MONSTERS = {}
local t = 0

local SPAWNS = {
	ALKANIA1 = {{5, 5}, {95, 95}},
	ALKANIA2 = {{105, 5}, {135, 30}},
}

Skeleton = {limit = 0}
Skeleton_Toothroach = {limit = 0}
Skeleton_Runner = {limit = 0}
Skeleton_Spider = {limit = 0}

CONFIG.MONSTERS = {
	{
		name = 'Skeleton_Toothroach', limit = 9, health = 120, maxhealth = 120, image = 'gfx/yates/RPG/Skeleton Roach.png', scalex = 1, scaley = 1, 
		atk = 0.4, def = 1, spd = 15, atkspd = 4, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {70}}, 
		size = 16,
		spawn = {
			['rpg_mapb'] = {SPAWNS.ALKANIA1}
		}, 
		exp = 8, money = 8, loot = {{chance = 7000, id = 552}},
	}, 
	{
		name = 'Skeleton', health = 200, limit = 26, maxhealth = 200, image = 'gfx/yates/RPG/Skeleton.png', scalex = 1, scaley = 1, 
		atk = 1.8, def = 1.8, spd = 7, atkspd = 6, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {80}}, 
		size = 32,
		spawn = {
			['rpg_mapb'] = {SPAWNS.ALKANIA1}
		}, 
		exp = 22, money = 15, loot = {{chance = 7000, id = 552}},
	}, 
	{
		name = 'Skeleton_Runner', health = 300, limit = 7, maxhealth = 300, image = 'gfx/yates/RPG/Skeleton Runner.png', scalex = 1, scaley = 1, 
		atk = 2.2, def = 2.5, spd = 22, atkspd = 8, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {40}}, 
		size = 48,
		spawn = {
			['rpg_mapb'] = {SPAWNS.ALKANIA1}
		}, 
		exp = 54, money = 44, loot = {{chance = 7000, id = 552}},
	},
	{
		name = 'Skeleton_Spider', health = 500, limit = 3, maxhealth = 500, image = 'gfx/yates/RPG/Skeleton Spider.png', scalex = 1, scaley = 1, 
		atk = 3, def = 3, spd = 8, atkspd = 4, x = 0, y = 0, ang = 0, imgang = 0, runat = 10, 
		spawnchance = {['rpg_mapb'] = {40}}, 
		size = 48,
		spawn = {
			['rpg_mapb'] = {SPAWNS.ALKANIA2}
		}, 
		exp = 54, money = 72, loot = {{chance = 7000, id = 552}},
	},
}

CONFIG.MONSTERSKILLS = {
	endExplode = function(id)
		self = MONSTERS[tonumber(id)]
		self.spd = self._spd
		self._spd = nil
		imagecolor(self.image, 255, 255, 255)
		self.explode = nil
		self:die()
	end,
}

addhook("attack", "MONSTERattack")
function MONSTERattack(id)
	if gettile(PLAYERS[id].x, PLAYERS[id].y).SAFE or gettile(PLAYERS[id].x, PLAYERS[id].y).NOMONSTERS then
		return
	end
	if inarray({400, 401, 402, 403, 404, 405, 406}, PLAYERS[id].Equipment[7]) then
		msg2(id,"\169255150150[SERVER]:\169255255255 You are not allowed to attack on a horse.")
		return
	end
	local weapon, closest = player(id, 'weapontype')
	for _, m in ipairs(MONSTERS) do
		local x, y = player(id, 'x'), player(id, 'y')
		local dist = math.sqrt((m.x-x)^2+(m.y-y)^2)
		if dist <= (closest and closest[2] or (CONFIG.WEAPONRANGE[weapon] or CONFIG.WEAPONRANGE[50])) then
			local rot = player(id, 'rot')
			if math.abs(math.rad(rot) - math.atan2(y-m.y, x-m.x) + math.pi/2)%(2*math.pi) <= (CONFIG.WEAPONWIDTH[weapon] or CONFIG.WEAPONRANGE[50]) then
				if free_line(player(id,"x"),player(id,"y"),m.x,m.y) then
					--msg(string.char(169).."000255000Yes, the path from your character to your monster is clear.")
					closest = {m, dist}
				else
					--msg(string.char(169).."255000000No, the path from your character to your monster is not clear.")
				end
			end
		end
	end
	if closest then
		closest[1]:damage(id, math.ceil(20*((PLAYERS[id].Level+50)*PLAYERS[id].tmp.atk/closest[1].def)/math.random(60, 140)), weapon)
		PLAYERS[id].HTimer = 5
	end
end

addhook("ms100", "MONSTERms100")
function MONSTERms100()
	t = t + 1
	if t % 100 == 0 then
		while #MONSTERS < CONFIG.MAXMONSTERS do
			local rand, spawnNo, mapName
			while true do
				rand = math.random(#CONFIG.MONSTERS)
				mapName = CONFIG.MONSTERS[rand].spawn[map'name'] and map'name' or CONFIG.DEFAULTMAP
				spawnNo = math.random(#CONFIG.MONSTERS[rand].spawn[mapName])
				if math.random(0, 100) < CONFIG.MONSTERS[rand].spawnchance[mapName][spawnNo] then
					break
				end
			end
			local m = deepcopy(CONFIG.MONSTERS[rand])
			local x, y, tilex, tiley
			local spawn = m.spawn[mapName][spawnNo]
			if _G[m.name].limit < m.limit then
				_G[m.name].limit = _G[m.name].limit + 1
				repeat
					tilex, tiley = math.random(spawn[1][1], spawn[2][1]), math.random(spawn[1][2], spawn[2][2])
				until not gettile(tilex, tiley).SAFE and
                not gettile(tilex, tiley).NOMONSTERS and
                tile(tilex, tiley, "walkable") and
                tile(tilex, tiley, "frame") ~= 34
				m.x, m.y = math.floor(tilex*32+16), math.floor(tiley*32+16)
				Monster:new(m)
			end
		end
	end
	for _, m in ipairs(MONSTERS) do
		if t % m.atkspd == 0 then
			m.target = nil
			local closest
			for _, p in ipairs(table.shuffle(player(0, 'table'))) do
				if player(p, 'health') > 0 and not gettile(PLAYERS[p].x, PLAYERS[p].y).SAFE and not gettile(PLAYERS[p].x, PLAYERS[p].y).NOMONSTERS then
					local dist = math.sqrt((player(p, 'x')-m.x)^2 + (player(p, 'y')-m.y)^2)
					if Player[p].repel == 1 or Player[p].invunerable == 1 then
						if dist > 128 then
							if not closest or dist < closest[2] then
								closest = {p, dist}
							end
						end
					else
						if dist < 400 then
							if not closest or dist < closest[2] then
								closest = {p, dist}
							end
						end
					end
				end
			end
			if closest then
				local dist = closest[2]
				if dist < 400 then
					m.target = closest[1]
					if m.spc and math.random(10000) <= m.spc[1] then
						m.spc[2](m, m.target, dist)
					elseif dist <= (m.range or 32) then
						m:hit(m.target, 10)
						PLAYERS[m.target].HTimer = 5
					end
				end
			end
		end
		if m.target and player(m.target, 'exists') and player(m.target, 'health') > 0 and
			not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).SAFE and
			not gettile(PLAYERS[m.target].x, PLAYERS[m.target].y).NOMONSTERS then
			xdist, ydist = player(m.target, 'x') - m.x, player(m.target, 'y') - m.y
			local dist = math.sqrt(xdist^2 + ydist^2)
			if dist < 400 then
				m.ang = math.atan2(ydist, xdist)-math.pi/2+math.random(-1, 1)/2
			else
				m.target = nil
			end
		end
		if not m.target then
			m:rot(math.random(-1, 1)/2)
		end
		m.imgang = math.deg(m.ang)
		if not m:move(m:rot(), m.health > m.runat and 1 or -1) then
			repeat until m:move(math.rad(math.random(360)), 1)
		end
	end
end

function Monster:new(m)
	if not (m.x or m.y) then return false end
	m.image = image(m.image, m.x, m.y, 0)
	imagescale(m.image, m.scalex, m.scaley)
	setmetatable(m, self)
	self.__index = self
	local n = #MONSTERS+1
	MONSTERS[#MONSTERS+1] = m
	m.id = n
	return m
end

function Monster:pos(x, y)
	if not x and not y then
		return self.x, self.y
    else
        if not occupied(x,y,self.id) then
		    self.x, self.y = x or self.x, y or self.y
        end
		for all = 1, 17 do
			if player(all,"exists") and player(all,"health") > 0 then
				if player(all,"x") >= self.x-800 and player(all,"x") <= self.x+800 and player(all,"y") >= self.y-800 and player(all,"y") <= self.y+800 then
                    imagepos(self.image, self.x, self.y, self.imgang)
                    imagealpha(self.image, 1)
                    break
				end
			end
			if all == 17 then
				imagealpha(self.image, 0)
			end
		end
	end
	return true
end

function Monster:move(dir, amt,monsterid) --this function just gives true or false, but not coordinates, nor monster ID, right? yep, just checks
    local x, y = -math.sin(dir)*amt*self.spd, math.cos(dir)*amt*self.spd
    local x, y = self.x+x, self.y+y
    local tilex, tiley = math.floor(x/32), math.floor(y/32)
    if tile(tilex, tiley, 'walkable') and tile(tilex, tiley, 'frame') ~= 34 and
            not gettile(tilex, tiley).SAFE and
            not gettile(tilex, tiley).NOMONSTERS  then
        self:pos(x, y)
        return true
    else
        self:rot(math.random(-1, 1)*math.pi/2)
        return false
    end
end

function occupied(x,y,monsterid)
    for n, m in pairs (MONSTERS) do
        if monsterid ~= n and math.sqrt(math.pow(math.abs(m.x-x),2) + math.pow(math.abs(m.y-y),2)) <= m.size then
            return true
        end
    end
    return false
end

function Monster:damage(id, dmg, wpntype)
	if not PLAYERS[id].Tutorial.damagem then
        msg2(id,"\169150255150[SERVER]:\169255255255 You've attacked a monster (mob). Keep hitting it until it dies!")
		PLAYERS[id].Tutorial.damagem = true
	end
	local wpnName
	if wpntype == 251 then
		wpnName = 'rune'
	elseif wpntype == 46 then
		wpnName = 'firewave'
		dmg = dmg/5
	else
		wpnName = PLAYERS[id].Equipment[3] and ITEMS[PLAYERS[id].Equipment[3]].name or 'dagger'
		if wpnName == "Machete [35]" then
			local chance = math.random(1,15)
			if chance == 1 then
				local dmgchance = math.random(1,dmg)
				msg2(id,"\169150255150[COMBAT]:\169255255255 You have set the mob alight, "..dmgchance.." extra damage!")
				parse('effect "fire" '..self.x..' '..self.y..' 30 30')
				dmg = dmg + dmgchance
			end
		elseif wpnName == "Machete [55]" then
			local chance = math.random(1,10)
			if chance == 1 then
				local dmgchance = math.random(1,dmg)
				msg2(id,"\169150255150[COMBAT]:\169255255255 You have set the mob alight, "..dmgchance.." extra damage!")
				parse('effect "fire" '..self.x..' '..self.y..' 50 50')
				dmg = dmg + dmgchance
			end
		elseif wpnName == "Ancient Battleaxe [65]" then
			local chance = math.random(1,20)
			if chance == 1 then
				msg2(id,"\169150255150[COMBAT]:\169255255255 Lucky bastard, you have dealt double damage!")
				Player[id].battleaxei1 = image("gfx/yates/RPG/wave.png",0,0,100+id)
				imagescale(Player[id].battleaxei1,0.1,0.1)
				imageblend(Player[id].battleaxei1,1)
				imagealpha(Player[id].battleaxei1,0.2)
				imagecolor(Player[id].battleaxei1,250,0,0)
				tween_scale(Player[id].battleaxei1,200,50,50)
				timer(150,"freeimage",Player[id].battleaxei1)
                timer(150,"parse","lua "..Player[id].battleaxei1.."=nil")
				dmg = dmg * 2
			end
		elseif wpnName == "Ancient Battleaxe [90]" then
			local chance = math.random(1,15)
			if chance == 1 then
				msg2(id,"\169150255150[COMBAT]:\169255255255 Lucky bastard, you have dealt TRIPLE damage!")
				Player[id].battleaxei1 = image("gfx/yates/RPG/wave.png",0,0,100+id)
				imagescale(Player[id].battleaxei1,0.1,0.1)
				imageblend(Player[id].battleaxei1,1)
				imagealpha(Player[id].battleaxei1,0.3)
				imagecolor(Player[id].battleaxei1,250,0,0)
				tween_scale(Player[id].battleaxei1,200,50,50)
				timer(150,"freeimage",Player[id].battleaxei1)
                timer(150,"parse","lua "..Player[id].battleaxei1.."=nil")
				dmg = dmg * 3
			end
		end
	end
	self.health = self.health - dmg
	if self.health < 0 then
		self.health = 0
	end
	hudtxt2(id,30,''..self.name..'', '255150150',470,424,0)
	hudtxt2(id,31,'Damage dealt: '..dmg..'', '150150150',470,439,0)
	hudtxt2(id,32,'Monster health: '..self.health..'/'..self.maxhealth..'', '150150150',470,454,0)
	freetimer("parse","hudtxtalphafade "..id.." 30 500 0")
	freetimer("parse","hudtxtalphafade "..id.." 31 500 0")
	freetimer("parse","hudtxtalphafade "..id.." 32 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 30 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 31 500 0")
	timer(1500,"parse","hudtxtalphafade "..id.." 32 500 0")
	if self.health <= 0 then
		if not PLAYERS[id].Tutorial.killm then
            msg2(id,"\169150255150[SERVER]:\169255255255 Congratulations! You have killed your first monster. You can proceed to pick up the loot by pressing G.")
			PLAYERS[id].Tutorial.killm = true
		end
		if self.name == "Skeleton" then
			if PLAYERS[id].q5 == 1 then
				PLAYERS[id].q5m = PLAYERS[id].q5m + 1
				freetimer("parse","hudtxtalphafade "..id.." 41 500 0")
				if PLAYERS[id].q5m ~= 100 then
					hudtxt2(id,41,'\169000255000Skeleton: '..PLAYERS[id].q5m..'/100', '255255255',320,391,1)
					timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
				elseif PLAYERS[id].q5m == 100 then
					hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mahn and finish the quest.', '255255255',320,391,1)
					timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
					PLAYERS[id].q5 = 2
				end
			elseif PLAYERS[id].q5 == 2 then
				hudtxt2(id,41,'\169255100000[QUEST]:\169255255255 Go and speak to Mahn and finish the quest.', '255255255',320,391,1)
				timer(6000,"parse","hudtxtalphafade "..id.." 41 500 0")
			end
        end
		if PLAYERS[id].tmp.party[1] ~= 0 then
			local teamp = 0
			local pexp = 0
			for i = 1, 4 do
				if player(PLAYERS[id].tmp.party[i],"exists") then
					teamp = teamp + 1
				end
				if i == 4 then
					for all = 1, 4 do
						if player(PLAYERS[id].tmp.party[all],"exists") then
							pexp = math.floor(self.exp*CONFIG.EXPRATE/teamp)
							addexp(PLAYERS[id].tmp.party[all],pexp)
							msg2(PLAYERS[id].tmp.party[all],"\169150255255[EXP]:\169255255255 "..player(id,"name").." has gained you "..pexp.." experience.")
						end
					end
				end
			end
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(1,120))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(121,240))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(241,360))
			self:die()
        else
            if Player[id].p_mastery == 2 then
                pexp = math.floor(self.exp*CONFIG.EXPRATE)
                addexp(id,pexp*1.10)
                msg2(id,"\169150255255[EXP]:\169255255255 You have gained "..pexp.." experience (+"..math.floor((self.exp*CONFIG.EXPRATE*0.10))..").")
            else
                pexp = math.floor(self.exp*CONFIG.EXPRATE)
                addexp(id,pexp)
                msg2(id,"\169150255255[EXP]:\169255255255 You have gained "..pexp.." experience.")
            end
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(1,120))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(121,240))
			parse("spawnprojectile "..id.." 86 "..self.x.." "..self.y.." 48 "..math.random(241,360))
			self:die()
		end
	else
		parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' 0 ' .. self.scaley .. ' ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	end
	radiussound("weapons/machete_hit.wav", self.x, self.y)
	return true
end

function Monster:hit(id, dmg)
    dmg = math.floor(tonumber(dmg))
	if not PLAYERS[id].Tutorial.hitm then
        msg2(id,"\169255150150[SERVER]:\169255255255 A monster is attacking you! You can fight back by swinging your weapon at it (left click).")
		PLAYERS[id].Tutorial.hitm = true
    end
    EXPhit(id, self, -1, dmg)
	radiussound("weapons/knife_hit.wav", self.x, self.y)
	return true
end

function Monster:die(id)
	local size = self.scalex+self.scaley
	parse('effect "colorsmoke" ' .. self.x .. ' ' .. self.y .. ' ' .. size .. ' 64 ' .. (self.r and (self.r .. ' ' .. self.g .. ' ' .. self.b) or '192 0 0'))
	local tilex, tiley = math.floor(self.x/32), math.floor(self.y/32)
	spawnitem(1337, tilex, tiley, math.floor(self.money*math.random(50, 150)/100)*CONFIG.MONEYRATE)
	for _, loot in ipairs(self.loot) do
		local chance = math.random(100)
		if chance <= loot.chance then
			spawnitem(loot.id, tilex, tiley)
		end
	end
	_G[self.name].limit = _G[self.name].limit - 1
	radiussound("weapons/c4_explode.wav", self.x, self.y)
	self:destroy()
end

function Monster:destroy()
	freeimage(self.image)
	local found
	table.remove(MONSTERS, self.id)
	for i, m in ipairs(MONSTERS) do
		m.id = i
	end
	return true
end

function Monster:rot(rot)
	if not rot then
		return self.ang
	else
		self.ang = (self.ang+rot)%(math.pi*2)
	end
	return true
end