-- tw_abilities.lua --

function _ability_join(id)
	Player[id].predator = 0
	Player[id].pyromaniac = 0
	Player[id].toxygen = 0
	Toxygen[id] = {0,0,0,0}
	Player[id].leech = 0
	Player[id].forcefield = 0
	Player[id].kamikaze = 0
	Player[id].regeneration = 0
	Player[id].regentime = 0
	Player[id].regenend = 0
end

function _ability_predator(id)
	id = tonumber(id)
	local pos = player(id,"x").." "..player(id,"y")
	
	Player[id].predatori = image("gfx/yates/lua/abilities/predator.png",0,-1,200+id)
	imagealpha(Player[id].predatori,0.8)
	imageblend(Player[id].predatori,1)
	tween_rotateconstantly(Player[id].predatori,3)
	tween_alpha(Player[id].predatori,500,0)
	if Player[id].rankimage then
		imagealpha(Player[id].rankimage,0.1)
	end
	if Player[id].medicicon then
		imagealpha(Player[id].medicicon,0.1)
	end
	if Player[id].engineericon then
		imagealpha(Player[id].engineericon,0.1)
	end
	parse("setarmor "..id.." 206")
	parse("effect \"smoke\" "..pos.." 50 50")
	Player[id].predator = 1
	timer(500,"freeimage",Player[id].predatori)
	timer(20000,"_ability_predator_end",id)
end

function _ability_predator_end(id)
	id = tonumber(id)
	
	if Player[id].rankimage then
		imagealpha(Player[id].rankimage,1)
	end
	if Player[id].medicicon then
		imagealpha(Player[id].medicicon,0.6)
	end
	if Player[id].engineericon then
		imagealpha(Player[id].engineericon,1)
	end
	parse("setarmor "..id.." 65")
	Player[id].predator = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, predator, has ended.")
end

function _ability_pyromaniac(id)
	id = tonumber(id)
	
	Player[id].pyromaniaci = image("gfx/yates/lua/abilities/pyromaniac.png",-1,-1,100+id)
	tween_rotateconstantly(Player[id].pyromaniaci,2)
	parse("equip "..id.." 46")
	parse("setweapon "..id.." 46")
	Player[id].pyromaniac = 1
	timer(15000,"_ability_pyromaniac_end",id)
end

function _ability_pyromaniac_end(id)
	id = tonumber(id)
	
	freeimage(Player[id].pyromaniaci)
	parse("strip "..id.." 46")
	parse("setweapon "..id.." 50")
	Player[id].pyromaniac = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, pyromaniac, has ended.")
end

function _ability_toxygen(id)
	id = tonumber(id)
	
	Player[id].toxygeni = image("gfx/yates/lua/abilities/toxygen.png",-1,-1,100+id)
	imagecolor(Player[id].toxygeni,90,125,0)
	tween_rotateconstantly(Player[id].toxygeni,2)
	Player[id].toxygen = 1
	timer(18000,"_ability_toxygen_end",id)
end

function _ability_toxygen_end(id)
	id = tonumber(id)
	
	freeimage(Player[id].toxygeni)
	Player[id].toxygen = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	Toxygen[id] = {0,0,0,0}
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, toxygen, has ended.")
end

function _ability_leech(id)
	id = tonumber(id)
	
	Player[id].leechi = image("gfx/yates/lua/abilities/leech.png",-1,-1,200+id)
	imagealpha(Player[id].leechi,0.8)
	imagescale(Player[id].leechi,0.3,0.3)
	tween_rotateconstantly(Player[id].leechi,3)
	Player[id].leech = 1
	timer(10000,"_ability_leech_end",id)
end

function _ability_leech_end(id)
	id = tonumber(id)
	
	freeimage(Player[id].leechi)
	Player[id].leech = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, leech, has ended.")
end

function _ability_forcefield(id)
	id = tonumber(id)
	
	Player[id].forcefieldi = image("gfx/yates/lua/abilities/force_field.png",-1,-1,200+id)
	imagealpha(Player[id].forcefieldi,0.8)
	imagescale(Player[id].forcefieldi,0.5,0.5)
	tween_rotateconstantly(Player[id].forcefieldi,3)
	Player[id].forcefield = 1
	timer(3000,"_ability_forcefield_end",id)
end

function _ability_forcefield_end(id)
	id = tonumber(id)
	
	freeimage(Player[id].forcefieldi)
	Player[id].forcefield = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, force field, has ended.")
end

function _ability_kamikaze(id)
	id = tonumber(id)
	
	parse("spawnprojectile "..id.." 47 "..player(id,"x").." "..player(id,"y").." 256 "..math.random(1,120))
	parse("spawnprojectile "..id.." 47 "..player(id,"x").." "..player(id,"y").." 256 "..math.random(121,240))
	parse("spawnprojectile "..id.." 47 "..player(id,"x").." "..player(id,"y").." 256 "..math.random(241,360))
	parse("explosion "..player(id,"x").." "..player(id,"y").." 150 500 "..id)
	parse("killplayer "..id)
	Player[id].kamikaze = 1
	timer(0,"_ability_kamikaze_end",id)
end

function _ability_kamikaze_end(id)
	id = tonumber(id)

	Player[id].kamikaze = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, kamikaze, has ended.")
end

function _ability_regeneration(id)
	id = tonumber(id)
	
	local chance = math.random(5,10)
	Player[id].regeni = image("gfx/yates/lua/abilities/regeneration.png",player(id,"x"),player(id,"y"),3)
	imagealpha(Player[id].regeni,0.8)
	tween_move(Player[id].regeni,3000,player(id,"x"),player(id,"y")-50,0)
	tween_alpha(Player[id].regeni,3000,0)
	parse("sethealth "..id.." "..player(id,"health")+chance)
	Player[id].regentime = 0
	Player[id].regeneration = 1
end

function _ability_regeneration_end(id)
	id = tonumber(id)
	
	freeimage(Player[id].regeni)
	Player[id].regentime = 0
	Player[id].regenend = 0
	Player[id].regeneration = 0
	Player[id].ability = 0
	Player[id].ability_time = 100
	msg2(id,"\169150255150[SERVER]:\169255255255 Your ability, regeneration, has ended.")
end

function _ability_hit(id,source,weapon,hpdmg,apdmg)
	if player(source,"exists") then
		if player(id,"team") ~= player(source,"team") then
			if id ~= source then
				if Player[source].leech == 1 then
					local leech = math.random(1,hpdmg)/2
					parse("sethealth "..source.." "..player(source,"health")+leech)
					imagecolor(Player[source].leechi,255,0,0)
					tween_color(Player[source].leechi,200,255,255,255)
				end
				if Player[id].forcefield == 1 then
					local walls = {}
					for x=-1,1 do
						for y=-1,1 do
							local x2=player(id,"tilex")+x
							local y2=player(id,"tiley")+y
							if tile(x2,y2,"walkable") and entity(x2,y2,"exists")==false then
								table.insert(walls,{x2,y2})
								parse("spawnobject 5 "..x2.." "..y2.." 0 0 0 0")
							end
						end
					end
					for _,wall in pairs(walls) do
						local wall=objectpos(wall[1],wall[2],"id")
						if wall~=false then
							timer(0,"parse","killobject "..wall)
						end
					end
					local health = player(id,"health")
					timer(0,"parse","sethealth "..id.." "..health)
					imagecolor(Player[id].forcefieldi,50,255,50)
					tween_color(Player[id].forcefieldi,500,255,255,255)
				end
			end
		end
	end
end

function _ability_movetile(id)
	if Player[id].toxygen == 1 then
		Toxygen[id] = {player(id,"tilex")-1,player(id,"tiley")-1,player(id,"tilex")+1,player(id,"tiley")+1}
	end
end

function _ability_second()
	for _,all in pairs(player(0,"table")) do
		for _,id in pairs(player(0,"table")) do
			if id ~= all then
				if player(id,"team") ~= player(all,"team") then
					if Player[all].toxygen == 1 then
						if player(id,"tilex") >= Toxygen[all][1] and player(id,"tiley") >= Toxygen[all][2] and player(id,"tilex") <= Toxygen[all][3] and player(id,"tiley") <= Toxygen[all][4] then
							parse("effect \"colorsmoke\" "..player(id,"x").." "..player(id,"y").." 2 1 85 125 40")
							parse("sethealth "..id.." "..player(id,"health")-math.random(5,10))
							parse("speedmod "..id.." "..player(id,"speedmod")-2)
							freetimer("parse","speedmod "..id.." 0")
							timer(5000,"parse","speedmod "..id.." 0")
						end
					end
				end
			end
		end
		if Player[all].regeneration == 1 then
			Player[all].regentime = Player[all].regentime + 1
			Player[all].regenend = Player[all].regenend + 1
			if Player[all].regenend ~= 30 then
				if Player[all].regentime == 3 then
					local chance = math.random(5,10)
					freeimage(Player[all].regeni)
					Player[all].regeni = image("gfx/yates/lua/abilities/regeneration.png",player(all,"x"),player(all,"y"),3)
					imagealpha(Player[all].regeni,0.8)
					tween_move(Player[all].regeni,3000,player(all,"x"),player(all,"y")-50,0)
					tween_alpha(Player[all].regeni,3000,0)
					parse("sethealth "..all.." "..player(all,"health")+chance)
					Player[all].regentime = 0
				end
			else
				timer(0,"_ability_regeneration_end",all)
			end
		end
	end
end

-- Seperate functions

function objectpos(x,y,value)
	for _,obj in pairs(object(0,"table")) do
		if object(obj,"tilex")==x and object(obj,"tiley")==y then
			if string.lower(value)=="id" then
				return obj
			else
				return object(obj,value)
			end
		end
	end
	return false
end