-- tw_server.lua --

-- Dofiles
dofile("sys/lua/trench_wars/tw_admin.lua")
dofile("sys/lua/trench_wars/tw_func.lua")
dofile("sys/lua/trench_wars/tw_abilities.lua")
dofile("/home/ftpuser/cs2d/reroute_details.lua")

-- Hooks
print("[SERVER]: Loading hooks.")
addhook("join","tw_join")
addhook("leave","tw_leave")
addhook("spawn","tw_spawn")
addhook("hit","tw_hit")
addhook("kill","tw_kill")
addhook("die","tw_die")
addhook("team","tw_team")
addhook("walkover","tw_walkover")
addhook("drop","tw_drop")
addhook("use","tw_use")
addhook("select","tw_select")
addhook("serveraction","tw_serveraction")
addhook("menu","tw_menu")
addhook("dominate","tw_dominate")
addhook("buildattempt","tw_buildattempt")
addhook("endround","tw_endround")
addhook("movetile","tw_movetile")
addhook("buy","tw_buy")
addhook("second","tw_second")

addhook("say","tw_say")
addhook("minute","tw_minute")

print("[SERVER]: Setting Lua variables.")
rankexp = 	{1500,4000,8000,12500,19000,25000,32500,40000,47500,55000,65000,75000,85000,100000,115000,130000,145000,165000,185000,225000,275000,325000,375000,425000,500000}
rankloc = 	{[0] = "rank1_bronze",
			"rank2_bronze","rank3_bronze","rank1_silver","rank2_silver","rank3_silver","rank4_silver","rank1_gold","rank2_gold","rank3_gold","rank4_gold","bar_bronze","bar_red","bar1_striped_silver","bar2_striped_silver","bar_silver","bar1_striped_gold","bar2_striped_gold","bar_gold","star_bronze","star_silver","star_gold","eagle_bronze","eagle_silver","eagle_gold"}
ranknme = 	{[0] = "Noob",
			"Private","Private","Corporal","Corporal","Corporal","Corporal","Sergent","Staff Sergent","Master Sergent","First Sergent","Officer","Warrant Officer","Lieuntenant","Second Lieuntenant","First Lieuntenant","Captain","Major","Colonel","Brigadier General","Major General","Lieutenant General","General","Master General","General of the Army"}

-- Tables
Player = {}
Turret = {}
Toxygen = {}
medic_t_tile = {0,0}
medic_ct_tile = {0,0}

tw_weapon_stats = {}
tw_weapons_cnt = 0

-- Lua settings
hudtxt_colorfade = 0
hudtxt_color1 = "255 0 0"
hudtxt_color2 = "255 255 0"

minute_info = 0
scalps_max = 250
medic_t = 0
medic_ct = 0

restart_minute = 19
restart_second = 59

sn = 4
site = "www.theanalbagels.eu"

print("[SERVER]: Parsing settings.")
-- Parse settings
parse("sv_fow 0")
parse("mp_infammo 1")
parse("mp_hud 43")
parse("mp_autoteambalance 1")
parse("mp_respawndelay 2")

parse("mp_building_limit Barricade 999")
parse("mp_building_limit \"Barbed Wire\" 999")
parse("mp_building_limit \"Wall I\" 999")
parse("mp_building_limit \"Wall II\" 999")
parse("mp_building_limit \"Wall III\" 999")
parse("mp_building_limit \"Gate Field\" 999")
parse("mp_building_limit Dispenser 999")
parse("mp_building_limit Turret 999")
parse("mp_building_limit Supply 999")
parse("mp_building_limit \"Teleporter Exit\" 999")
parse("mp_building_limit \"Teleporter Entrance\" 999")

parse("mp_building_price Barricade 0")
parse("mp_building_price \"Barbed Wire\" 0")
parse("mp_building_price \"Wall I\" 0")
parse("mp_building_price \"Wall II\" 0")
parse("mp_building_price \"Wall III\" 0")
parse("mp_building_price \"Gate Field\" 0")
parse("mp_building_price Dispenser 0")
parse("mp_building_price Turret 0")
parse("mp_building_price Supply 0")
parse("mp_building_price \"Teleporter Exit\" 0")
parse("mp_building_price \"Teleporter Entrance\" 0")

parse("mp_unbuildable \"\"")

print("[SERVER]: Executing functions.")
-- Executeable functions
_loadWeapons()