local usgndb = {}

function usgndb:new(name)
    local udb = setmetatable({}, {__index = usgndb})
    if (type(name) == "string") then
        udb:load(name)
    end
    return udb
end

function usgndb:load(file)
    local db = {}

    local fh = io.open(file)
    for line in fh:lines() do
        local usgn, name
        line:gsub("(%d+),(.+)", function(a, b) usgn, name = tonumber(a), b end)
        db[usgn] = name
    end
    fh:close()

    self.db = db
    return self
end

function usgndb:lookup(usgn)
    if (self.db[usgn]) then
        return self.db[usgn]
    else
        return "UNALLOCATED"
    end
end

return usgndb.new()